package com.example.maze;


import android.app.Activity;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.view.Display;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity implements SensorEventListener {

	private SensorManager mSensorManager;
	private boolean mJudSensor;
	private TextView mTestText,mSizeText, mPosiText, mxyPosi;
	String sensorText;
	float[]	orientation = new float[AXIS_NUM];
	String orientText;
	
	private ImageView mFieldView, mBallView;
	
	public int fieldPlace[][] = new int[9][14];
	public int fieldState;
	
	public int showToastMiss = 1;
	public int showToastGoal = 1;
	public int showToastStart = 1;
	
	public int gravitySense = 2;	//n߂臒l
	public int gravityInflu = 2;	//
	
	//ZT[l
	private static final int AXIS_NUM = 3;
	float[] gravity = new float[AXIS_NUM];

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		
		setContentView(R.layout.activity_main);
	
		//text
		mTestText = (TextView)findViewById(R.id.testText);
		mSizeText = (TextView)findViewById(R.id.sizeText);
		mPosiText = (TextView)findViewById(R.id.posiText);
		mxyPosi = (TextView)findViewById(R.id.xyPosi);
		//view
		mFieldView = (ImageView)findViewById(R.id.fieldView);
		mBallView = (ImageView)findViewById(R.id.ballView);
		
		//sensor
		mSensorManager = (SensorManager)getSystemService(SENSOR_SERVICE);
		mJudSensor = false;
		
		//size
		WindowManager windowManager = getWindowManager();
		Display display = windowManager.getDefaultDisplay();
		DisplayMetrics displayMetrics = new DisplayMetrics();
		display.getMetrics(displayMetrics);
		
		String sizeDisp = "width:"+displayMetrics.widthPixels+"\nheight:"+displayMetrics.heightPixels+
						  "\nwiddp:"+displayMetrics.xdpi+"\nheidp:"+displayMetrics.ydpi;
		mSizeText.setText(sizeDisp);	
		initFieldPlace();
	}
	
	@Override
	protected void onResume(){
		super.onResume();
		mSensorManager.registerListener(this, mSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION),SensorManager.SENSOR_DELAY_UI);
	}
	@Override
	protected void onStop(){
		super.onStop();
		mSensorManager.unregisterListener(this);
	}
	

	@Override
	public void onSensorChanged(SensorEvent event) {
		// TODO ꂽ\bhEX^u
		String sensorStr = "";

		if(event.sensor.getType() == Sensor.TYPE_ORIENTATION){
			orientation = event.values.clone();//擾?
			sensorStr = "XZT[:\nx="+String.format("%3.1f", orientation[0])+
									"\ny="+String.format("%3.1f", orientation[1])+
									"\nz="+String.format("%3.1f", orientation[2]);
	
		}
	
		moveBallPosition();
		mTestText.setText(sensorStr);
		if(judgePosition() == 0 && showToastMiss > 0){//miss
			mBallView.setX(0);
			mBallView.setY(0);
			showToastMiss = 0;
			Toast.makeText(this, "~X!!", Toast.LENGTH_SHORT).show();
			showToastGoal = 1;
		}
		if(judgePosition() == 1){
			showToastMiss = 1;
			showToastStart = 1;
		}
		if(judgePosition() == 2 && showToastStart > 0){//start
			showToastStart = 0;
			Toast.makeText(this, "X^[g!!", Toast.LENGTH_SHORT).show();
			showToastGoal = 1;
		}
		if(judgePosition() == 3 && showToastGoal > 0){//goal
			showToastGoal = 0;
			Toast.makeText(this, "S[!!!", Toast.LENGTH_SHORT).show();
			mBallView.setX(0);
			mBallView.setY(0);
			showToastStart = 1;
			showToastMiss = 1;
		}
		
	}

	//{[ړ
	private void moveBallPosition() {
		// TODO ꂽ\bhEX^u
		//ړ
		String potision = "";
		potision = "X="+mBallView.getX() + "Y="+mBallView.getY();
		mPosiText.setText(potision);
		
		//Eړ
		if(orientation[2] < -gravitySense && mBallView.getX() <= 960){
			float x;
			x = (float) (mBallView.getX()-(gravityInflu*orientation[2]));
			if(x >=960){
				x = 960;
			}
			mBallView.setX(x);
		}
		//ړ
		if(orientation[2] > gravitySense && mBallView.getX() >= 0){
			float x;
			x = mBallView.getX()-(gravityInflu*orientation[2]);
			if(x <= 0){
				x = 0;
			}
			mBallView.setX(x);
		}
		//ړ
		if(orientation[1] < -gravitySense && mBallView.getY() <= 1560){
			float y;
			y = mBallView.getY()-(gravityInflu*orientation[1]);
			if(y >= 1560){
				y = 1560;
			}
			mBallView.setY(y);
		}
		//ړ
		if(orientation[1] > gravitySense && mBallView.getY() >= 0){
			float y;
			y = mBallView.getY()-(gravityInflu*orientation[1]);
			if(y <= 0){
				y = 0;
			}
			mBallView.setY(y);
		}
	}
	
	//ꏊԂ
	private int judgePosition(){
		float xx = mBallView.getX();
		float yy = mBallView.getY();
		double xa;
		double ya;
		int x, y;
		 
		xa = (xx / 120) + 0.5;
		ya = (yy / 120) + 0.5;
		
		x = (int) xa;
		y = (int) ya;
		if(x >= 60){
			x++;
		}
		if(y >= 60){
			y++;
		}
		String str = "\n[x]:"+x +"\n[y]"+y;
		mxyPosi.setText(str);
		return fieldPlace[x][y];
	}
	
	private void initFieldPlace() {
		// TODO ꂽ\bhEX^u
		for(int i=0; i<9; i++){
			for(int j=0; j<14; j++){
				fieldPlace[i][j] = 0;
			}
		}
		//(=1)
		fieldPlace[0][0] = 2;//start
		fieldPlace[0][1] = 1;
		fieldPlace[0][2] = 1;
		
		fieldPlace[1][2] = 1;
		fieldPlace[1][5] = 1;
		fieldPlace[1][6] = 1;
		fieldPlace[1][7] = 1;
		fieldPlace[1][8] = 1;
		
		fieldPlace[2][2] = 1;
		fieldPlace[2][5] = 1;
		fieldPlace[2][7] = 1;
		fieldPlace[2][12] = 1;
		fieldPlace[2][13] = 3;//goal
		
		fieldPlace[3][1] = 1;
		fieldPlace[3][2] = 1;
		fieldPlace[3][3] = 1;
		fieldPlace[3][4] = 1;
		fieldPlace[3][5] = 1;
		fieldPlace[3][7] = 1;
		fieldPlace[3][11] = 1;
		fieldPlace[3][12] = 1;
		
		fieldPlace[4][1] = 1;
		fieldPlace[4][7] = 1;
		fieldPlace[4][11] = 1;
		
		fieldPlace[5][1] = 1;
		fieldPlace[5][5] = 1;
		fieldPlace[5][6] = 1;
		fieldPlace[5][7] = 1;
		fieldPlace[5][11] = 1;
		fieldPlace[5][12] = 1;
		
		fieldPlace[6][1] = 1;
		fieldPlace[6][2] = 1;
		fieldPlace[6][3] = 1;
		fieldPlace[6][5] = 1;
		fieldPlace[6][11] = 1;
		
		fieldPlace[7][5] = 1;
		fieldPlace[7][6] = 1;
		fieldPlace[7][7] = 1;
		fieldPlace[7][8] = 1;
		fieldPlace[7][9] = 1;
		fieldPlace[7][10] = 1;
		fieldPlace[7][11] = 1;
		
	}
	
	
	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO ꂽ\bhEX^u
	}

	
	
}
